%{
#include "hman.h"
#undef output

static int new_line = 2;
static int header = 1;

output(c)
{
	/* compress the multiple empty lines */

	if(c=='\n')
	{
		if(new_line<2) putc(c,yyout);
		new_line++;
	}
	else
	{
		putc(c,yyout);
		new_line = 0;
	}	
}
%}

BLANK	[ \t]*
WORD	[a-zA-Z]+[a-zA-Z0-9_\-\.]*
SECTION "("[0-9][A-Za-z0-9]*")"
REF	{WORD}{BLANK}{SECTION}

%%


^[ ]?{REF}.*$ { 
				/* header : CMD(SEC)	COMMAND TYPE    CMD(SEC) */
				/* display only one header */

				if(header) 
				{ 
					ECHO; 
					new_line = 0;
					output('\n');
					header=0;
				}
			}

{REF}	  { 
				/* ref : cmd(sec) */
				output(START_OF_HIGHLIGHT);
				ECHO;
				output(END_OF_HIGHLIGHT);
		   }

^Sun.*$ { /* remove Sun's footers */}
^Reformatting.*$ {/* remove Reformatting message */}
^{BLANK}Hewlett.*$ { /* remove Hewlett's footers */}
^{BLANK}-{BLANK}[0-9][0-9]*{BLANK}-.*$ { /* remove other Hewlett footers */}

%%

yywrap() 
{ 
	/* end of file, reset header and new_line flags */
	header = 1; 
	new_line = 2;
	return 1; 
}



